#!/usr/bin/env python3

import time
from prometheus_client import start_http_server, Summary, Gauge
import psycopg2
import mariadb

def query_postgres():
   conn = psycopg2.connect(
    host="postgres",
    database="lxf",
    user="mtsouk",
    password="pass")
   cur = conn.cursor()
   sql = "SELECT * from data"
   cur.execute(sql)

   row = cur.fetchone()

   i = 0
   while row is not None:
      row = cur.fetchone()
      i = i +1

   cur.close()
   conn.close()

def query_mariadb():
   conn = mariadb.connect(
        user="root",
        password="pass",
        host="mariadb",
        database="lxf"
   )

   cursor = conn.cursor()
   cursor.execute("SELECT * from Data")
   row = cursor.fetchone()

   i = 0
   while row is not None:
      row = cursor.fetchone()
      i = i + 1

   cursor.close()
   conn.close()

if __name__ == '__main__':
   time.sleep(10)

   start_http_server(9002)
   mariadb_metric = Gauge('mariadb_time', 'Timing MariaDB Server')
   post_metric = Gauge('postgresql_time', 'Timing PostgreSQL Server')

   while True:
      # MariaDB first
      start = time.perf_counter()
      query_mariadb()
      finish = time.perf_counter()
      temp = finish - start
      mariadb_metric.set(temp)

      # Then PostgreSQL
      start = time.perf_counter()
      query_postgres()
      finish = time.perf_counter()
      temp = finish - start
      post_metric.set(temp)

      time.sleep(5)
