#!/usr/bin/env python3

import time
from prometheus_client import start_http_server, Summary, Gauge

# PostgreSQL database
import psycopg2

def query_index():
   conn = psycopg2.connect(
    host="postgres",
    database="lxf",
    user="mtsouk",
    password="pass")
   cur = conn.cursor()
   sql = "SELECT * from with_index where length(Message) > 10"
   cur.execute(sql)

   row = cur.fetchone()

   i = 0
   while row is not None:
      row = cur.fetchone()
      i = i +1

   cur.close()
   conn.close()

def query_without():
   conn = psycopg2.connect(
    host="postgres",
    database="lxf",
    user="mtsouk",
    password="pass")
   cur = conn.cursor()
   sql = "SELECT * from without_index where length(Message) > 10"
   cur.execute(sql)

   row = cur.fetchone()

   i = 0
   while row is not None:
      row = cur.fetchone()
      i = i +1

   cur.close()
   conn.close()


if __name__ == '__main__':
   time.sleep(5)
   start_http_server(9001)
   index = Gauge('with_index', 'A table with an index')
   no_index = Gauge('without_index', 'A table without an index')

   while True:
      start = time.perf_counter()
      query_index()
      finish = time.perf_counter()
      temp = finish - start
      print("With Index:", 100 * temp)
      # print(start, finish)
      index.set(100 * temp)

      s1 = time.perf_counter()
      query_without()
      f1 = time.perf_counter()
      t1 = f1 - s1
      print("Without Index:", 100 * t1)
      # print(s1, f1)
      no_index.set(100 * t1)

      time.sleep(15)

