#!/usr/bin/env python3

# https://www.learnsteps.com/writing-metrics-exporter-for-prometheus-using-python/
# https://github.com/prometheus/client_python

from prometheus_client import start_http_server, Summary, Gauge
from linux_metrics import *
import linux_metrics
import time

if __name__ == '__main__':
    start_http_server(9000)
    g = Gauge('cpu_util', 'CPU Utilisation')
    m = Gauge('mem_used', 'Memory Used')

    while True:
        cpu_pcts = cpu_stat.cpu_percents(5)
        i = 100 - cpu_pcts['idle']
        g.set(i)
        memused, _, _, _, _, _ = linux_metrics.mem_stat.mem_stats()
        m.set(memused/(1024*1024))
        print(i, memused/(1024*1024))
        time.sleep(4)
